* ==============================================================================================================================
* :             vic119, Alex Roublev ()
* :              10.12.2014, 27.04.2017
* :           /  
*                       SOAP-      https://npchk.nalog.ru/
* :      https://npchk.nalog.ru/ws2.doc
*
* :         27.04.2017        
*
* . :    WEB    / : http://infostart.ru/public/439808/
*                       Foxclub: http://forum.foxclub.ru/read.php?29,645686
*
* :          Microsoft XML Core Service  6 SP3 (msxml6.dll)
*                     - MSXML  4 SP2 (msxml4.dll)     Msxml2.XMLHTTP.4.0
*                      https://support.microsoft.com/ru-ru/help/269238/list-of-microsoft-xml-parser-msxml-versions
*
* :
*                    tcInn  -  
*                    tcKpp  -  
*                    tcDate - ,       '..'
*
* :               
* ==============================================================================================================================

CLEAR

LOCAL lcInn AS STRING, lcKpp AS STRING, lcDate AS STRING

lcInn = '6441012385'
lcKpp = '583601001'
lcDate = '08.12.2014'

?Check_INN_KPP(lcInn, lcKpp, lcDate)

FUNCTION Check_INN_KPP()

    LPARAMETERS tcInn AS STRING, tcKpp AS STRING, tcDate AS STRING

    LOCAL loHttp AS OBJECT, lcRequest AS STRING, lcResponse AS STRING, lnState AS INTEGER, loError AS OBJECT

    lnState = -1
    
    TEXT TO lcRequest TEXTMERGE PRETEXT 1 + 2 NOSHOW
    <?xml version="1.0" encoding="UTF-8"?>
    <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:req="http://ws.unisoft/FNSNDSCAWS2/Request">
       <soapenv:Header/>
       <soapenv:Body>
          <req:NdsRequest2>
             <req:NP INN="<<tcInn>>" KPP="<<tcKpp>>" DT="<<tcDate>>"/>
          </req:NdsRequest2>
       </soapenv:Body>
    </soapenv:Envelope>
    ENDTEXT

    TRY

        loHttp = CREATEOBJECT('Msxml2.XMLHTTP.6.0')

        WITH loHttp
            .OPEN('POST', 'http://npchk.nalog.ru/FNSNDSCAWS_2?wsdl', .F.)
            .setRequestHeader('Content-Type', 'text/xml; charset=utf-8')
            .setRequestHeader('Content-length', TRANSFORM(LEN(lcRequest)))
            .Send(lcRequest)

            DO WHILE .ReadyState <> 4
                DOEVENTS FORCE
            ENDDO
            lcResponse = .ResponseText
        ENDWITH

        lcResponse = STREXTRACT(lcResponse, '<S:Body>', '</S:Body>')
        CREATE CURSOR Rekvizit (INN V(12), KPP V(9), DT V(10), State I)
        XMLTOCURSOR(lcResponse, 'Rekvizit', 8192)

        IF RECCOUNT('Rekvizit') > 0
            lnState = Rekvizit.State
        ENDIF

    CATCH TO loError

        MESSAGEBOX('  : ' + CHR(13) + '   ' + TRANSFORM(loError.LINENO) + ' # ' + loError.MESSAGE, 16, '  ')

    ENDTRY

    USE IN SELECT('Rekvizit')

    RETURN ICASE ;
                (;
                    lnState = -1, '  /    ', ;
                    lnState =  0, '          ', ;
                    lnState =  1, '   ,        ', ;
                    lnState =  2, '   ', ;
                    lnState =  3, '      ,       ', ;
                    lnState =  4, '       ', ;
                    lnState =  5, ' ', ;
                    lnState =  6, '   ', ;
                    lnState =  7, '   ', ;
                    lnState =  8, '   ', ;
                    lnState =  9, '   ', ;
                    lnState = 11, '  ', ;
                    lnState = 12, '  ( 01.01.1991    )', ;
                    '(' + TRANSFORM(lnState) + ')       ' ;
                )
ENDFUNC